    PROGRAM

    INCLUDE('PrnProp.CLW')
    INCLUDE('DevMode.CLW')

    MAP
      MODULE('Win32API')
DeviceCapabilities      PROCEDURE(*CSTRING lpDeviceName,*CSTRING lpPort,LONG iIndex,<*STRING lpOutput>,<*STRING lpDevMode>),Long,PASCAL,RAW,NAME('DeviceCapabilitiesA')
      END !MODULE
    END !MAP

DC_BINS     EQUATE(6)
DC_BINNAMES EQUATE(12)

BinCount    LONG
BinNameBuffer &STRING

PrnName     CSTRING(30)
PortName    CSTRING(50)
PrnOutputBuffer &STRING
PrnDevMode  &STRING

Counter     LONG
TempString  &CSTRING
TempValue   &SHORT
Pos         LONG

BinQ        QUEUE
BinNumber     SHORT
BinName       STRING(24)
BinValue      LONG
            END !QUEUE
MessageString   STRING(1024)

    CODE
    PRINTERDIALOG('Choose a Printer',1)

    PrnName = PRINTER{PROPPRINT:Device}
    PortName = PRINTER{PROPPRINT:Port}
    PrnDevMode = PRINTER{PROPPRINT:DevMode}
    PrnOutputBuffer &= NULL
    PrnDevMode &= NULL

    ! Either of these calls are valid due to Omittable parameters in declaration
    ! BinCount = DeviceCapabilities(PrnName,PortName,DC_BINS,PrnOutputBuffer,PrnDevMode)
    BinCount = DeviceCapabilities(PrnName,PortName,DC_BINS,,)
    !

    IF BinCount > 0
      ! First Get the Bin Names
      PrnOutputBuffer &= NEW(STRING(24 * BinCount))

      IF DeviceCapabilities(PrnName,PortName,DC_BINNAMES,PrnOutputBuffer,)
        Pos = 1
        Counter = 1

        LOOP
          IF Pos > SIZE(PrnOutputBuffer)  ! Safety
            BREAK
          END !IF

          TempString &= ( ADDRESS(PrnOutputBuffer) + (Pos - 1) )  ! Cast CSTRING at the Address

          IF LEN(TempString) = 0  ! Null Item, Break
            BREAK

          ELSE
            BinQ.BinNumber = Counter
            BinQ.BinName = TempString  ! Assign CString to a String
            BinQ.BinValue = 0  ! Do not assign value yet
            ADD(BinQ)
            Counter += 1     ! Increment Counter
            Pos = Pos + 24   ! Next 24 Bytes
          END !IF
        END !LOOP
      END !IF
      DISPOSE(PrnOutputBuffer)

      ! Next Get Bin Values
      PrnOutputBuffer &= NEW(STRING(SIZE(TempValue) * BinCount))  ! Array of SHORTs

      IF DeviceCapabilities(PrnName,PortName,DC_BINS,PrnOutputBuffer,)
        Pos = 1
        Counter = 1

        LOOP
          IF Pos > SIZE(PrnOutputBuffer)  ! Safety
            BREAK
          END !IF

          TempValue &= ( ADDRESS(PrnOutputBuffer) + (Pos - 1) )  ! Cast LONG at the Address

          BinQ.BinNumber = Counter
          GET(BinQ, BinQ.BinNumber)
          ASSERT(ERRORCODE() = 0)

          BinQ.BinValue = TempValue  ! assign value
          PUT(BinQ)

          Counter += 1     ! Increment Counter
          Pos = Pos + SIZE(TempValue)   ! Next SHORT
          
        END !LOOP
      END !IF
      DISPOSE(PrnOutputBuffer)

      MessageString = 'Bin Count for ' & PrnName & ' is ' & BinCount

      LOOP Counter = 1 TO RECORDS(BinQ)
        GET(BinQ,Counter)
        MessageString = CLIP(MessageString) & '|Bin ' & Counter & ': "' & CLIP(BinQ.BinName) & '" Value: ' & BinQ.BinValue
      END !LOOP

      MESSAGE(MessageString)

    ! Clean-up
      TempString &= NULL
      TempValue &= NULL
      FREE(BinQ)
      
    ELSE
      Message('No Bins for ' & PrnName & ' on ' & PortName)
    END !IF

    RETURN

